! --------------------------------------------------------------------------------------------- !
! Class description:	Drive information                                                       !
! Version:		1.1.0	                                                                !
! Copyright:		 2005 - 2006 All Rights Reserved by Roel S.F. Abspoel                  !
! --------------------------------------------------------------------------------------------- !
! Author:		Roel S.F. Abspoel (roel@abspoel.nl)                                     !
! Copyright:		 2005 All Rights Reserved by Roel S.F. Abspoel                         !
! --------------------------------------------------------------------------------------------- !


  MEMBER

  MAP
    MODULE('OutputDebugString')
        DI_OutputDebugString(*CSTRING),RAW,PASCAL,NAME('OutputDebugStringA')
    END
    MODULE('DriveInfoApis')
      DI_GetDiskFreeSpace(LONG, *ULARGE_INTEGER, *ULARGE_INTEGER, *ULARGE_INTEGER),BOOL,PROC,RAW,PASCAL,NAME('GetDiskFreeSpaceExA')
      DI_GetDriveType(*CString),UNSIGNED,PROC,PASCAL,RAW,NAME('GetDriveTypeA')
      DI_GetVolumeInformation(*CSTRING,*CSTRING,ULONG,*ULONG,*ULONG,*ULONG,*CSTRING,ULONG),BOOL,PROC,PASCAL,RAW,NAME('GetVolumeInformationA')
      DI_SetErrorMode(LONG),LONG,PROC,RAW,PASCAL,NAME('SetErrorMode')
      DI_WNetGetConnection(LONG,LONG,LONG),LONG,PROC,PASCAL,NAME('WNetGetConnectionA')
      DI_WNetGetUser(LONG,LONG,LONG),LONG,PROC,PASCAL,NAME('WNetGetUserA')
    END
    DI_GetDriveSpace(STRING,LONG,BYTE),STRING
    DI_GetDriveLabel(STRING),STRING
    DI_GetDriveSerial(STRING),STRING
    DI_GetDriveFat(STRING),STRING
    DI_GetDriveTypeName(STRING),STRING
    DI_FormatBytesSize(REAL),STRING
    DI_ChangeLongToHex(ULONG, BYTE LowerCase = FALSE),STRING
    DI_ChangeByteToHex(BYTE, BYTE LowerCase = FALSE),STRING
  END

  INCLUDE('DriveInfo.inc'),ONCE

DI_GetDriveTypeName	PROCEDURE(DriveLetter)
RootPathName	CSTRING(20)
DriveType	CSTRING(50)
        CODE
	IF LEN(DriveLetter) = 3 AND SUB(DriveLetter,-1,1) = '\'
	  RootPathName = DriveLetter
	  DriveType    = DI_GetDriveType(RootPathName)
	  CASE DriveType
	  OF 1
	    DriveType = 'No Root Dir'
	    RETURN(DriveType)
	  OF 2
	    DriveType = 'Removable'
	    RETURN(DriveType)
	  OF 3
	    DriveType = 'Fixed'
	    RETURN(DriveType)
	  OF 4
	    DriveType = 'Remote'
	    RETURN(DriveType)
	  OF 5
	    DriveType = 'CD-ROM'
	    RETURN(DriveType)
	  OF 6
	    DriveType = 'Ramdisk'
	    RETURN(DriveType)
	  ELSE
	    DriveType = 'Unknown'
	    RETURN(DriveType)
	  END
	ELSIF LEN(DriveLetter) = 2 AND SUB(DriveLetter,-1,1) = ':'
	  RootPathName = DriveLetter &'\'
	  DriveType    = DI_GetDriveType(RootPathName)
	  CASE DriveType
	  OF 1
	    DriveType = 'No Root Dir'
	    RETURN(DriveType)
	  OF 2
	    DriveType = 'Removable'
	    RETURN(DriveType)
	  OF 3
	    DriveType = 'Fixed'
	    RETURN(DriveType)
	  OF 4
	    DriveType = 'Remote'
	    RETURN(DriveType)
	  OF 5
	    DriveType = 'CD-ROM'
	    RETURN(DriveType)
	  OF 6
	    DriveType = 'Ramdisk'
	    RETURN(DriveType)
	  ELSE
	    DriveType = 'Unknown'
	    RETURN(DriveType)
	  END
	ELSIF LEN(DriveLetter) = 1
	  RootPathName = DriveLetter &':\'
	  DriveType    = DI_GetDriveType(RootPathName)
	  CASE DriveType
	  OF 1
	    DriveType = 'No Root Dir'
	    RETURN(DriveType)
	  OF 2
	    DriveType = 'Removable'
	    RETURN(DriveType)
	  OF 3
	    DriveType = 'Fixed'
	    RETURN(DriveType)
	  OF 4
	    DriveType = 'Remote'
	    RETURN(DriveType)
	  OF 5
	    DriveType = 'CD-ROM'
	    RETURN(DriveType)
	  OF 6
	    DriveType = 'Ramdisk'
	    RETURN(DriveType)
	  ELSE
	    DriveType = 'Unknown'
	    RETURN(DriveType)
	  END
	ELSE
	  MESSAGE('The driveletter specified needs|to be formated in one of these forms:|C|C:|C:\','GetDriveType',ICON:EXCLAMATION)
	END


DI_GetDriveSerial  PROCEDURE(DriveLetter)
RootPathName	CSTRING(20)
OldErrorMode	LONG
VolumeName      CSTRING(256)
VolumeNameSize  ULONG(256)
VolSerialNum    ULONG(15)
MaxCompLen      ULONG(15)
FileSysFlags    ULONG(15)
FileSysName     CSTRING(256)
FileSName       ULONG(256)
sTemp		CSTRING(10)
Serial		CSTRING(50)
        CODE
	IF LEN(DriveLetter) = 3 AND SUB(DriveLetter,-1,1) = '\'
	  RootPathName = DriveLetter
          OldErrorMode = DI_SetErrorMode(SEM_FAILCRITICALERRORS)
          DI_GetVolumeInformation(RootPathName, VolumeName, VolumeNameSize, VolSerialNum, MaxCompLen, FileSysFlags, FileSysName, FileSName)
          DI_SetErrorMode(OldErrorMode)
          IF VolSerialNum > 15
            sTemp = DI_ChangeLongToHex(VolSerialNum,0)
            Serial = SUB(sTemp,1,4) &'-'& SUB(sTemp,5,4)
          ELSE
            Serial = ''
          END
          Return(Serial)
	ELSIF LEN(DriveLetter) = 2 AND SUB(DriveLetter,-1,1) = ':'
	  RootPathName = DriveLetter &'\'
          OldErrorMode = DI_SetErrorMode(SEM_FAILCRITICALERRORS)
          DI_GetVolumeInformation(RootPathName, VolumeName, VolumeNameSize, VolSerialNum, MaxCompLen, FileSysFlags, FileSysName, FileSName)
          DI_SetErrorMode(OldErrorMode)
          IF VolSerialNum > 15
            sTemp = DI_ChangeLongToHex(VolSerialNum,0)
            Serial = SUB(sTemp,1,4) &'-'& SUB(sTemp,5,4)
          ELSE
            Serial = ''
          END
          Return(Serial)
	ELSIF LEN(DriveLetter) = 1
	  RootPathName = DriveLetter &':\'
          OldErrorMode = DI_SetErrorMode(SEM_FAILCRITICALERRORS)
          DI_GetVolumeInformation(RootPathName, VolumeName, VolumeNameSize, VolSerialNum, MaxCompLen, FileSysFlags, FileSysName, FileSName)
          DI_SetErrorMode(OldErrorMode)
          IF VolSerialNum > 15
            sTemp = DI_ChangeLongToHex(VolSerialNum,0)
            Serial = SUB(sTemp,1,4) &'-'& SUB(sTemp,5,4)
          ELSE
            Serial = ''
          END
          Return(Serial)
	ELSE
	  MESSAGE('The driveletter specified needs|to be formated in one of these forms:|C|C:|C:\','GetDriveSerial',ICON:EXCLAMATION)
	END

DI_GetDriveFat	PROCEDURE(DriveLetter)
RootPathName	CSTRING(20)
OldErrorMode	LONG
DriveType	LONG
DriveRemoteName	CSTRING(260)
DriveRemoteSize	LONG
VolumeName      CSTRING(256)
VolumeNameSize  ULONG(256)
VolSerialNum    ULONG(15)
MaxCompLen      ULONG(15)
FileSysFlags    ULONG(15)
FileSysName     CSTRING(256)
FileSName       ULONG(256)
sTemp		CSTRING(10)
Serial		CSTRING(50)
        CODE
	IF LEN(DriveLetter) = 3 AND SUB(DriveLetter,-1,1) = '\'
	  RootPathName = DriveLetter
          OldErrorMode = DI_SetErrorMode(SEM_FAILCRITICALERRORS)
          DI_GetVolumeInformation(RootPathName, VolumeName, VolumeNameSize, VolSerialNum, MaxCompLen, FileSysFlags, FileSysName, FileSName)
          DI_SetErrorMode(OldErrorMode)
          Return(FileSysName)
	ELSIF LEN(DriveLetter) = 2 AND SUB(DriveLetter,-1,1) = ':'
	  RootPathName = DriveLetter &'\'
          OldErrorMode = DI_SetErrorMode(SEM_FAILCRITICALERRORS)
          DI_GetVolumeInformation(RootPathName, VolumeName, VolumeNameSize, VolSerialNum, MaxCompLen, FileSysFlags, FileSysName, FileSName)
          DI_SetErrorMode(OldErrorMode)
          Return(FileSysName)
	ELSIF LEN(DriveLetter) = 1
	  RootPathName = DriveLetter &':\'
          OldErrorMode = DI_SetErrorMode(SEM_FAILCRITICALERRORS)
          DI_GetVolumeInformation(RootPathName, VolumeName, VolumeNameSize, VolSerialNum, MaxCompLen, FileSysFlags, FileSysName, FileSName)
          DI_SetErrorMode(OldErrorMode)
          Return(FileSysName)
	ELSE
	  MESSAGE('The driveletter specified needs|to be formated in one of these forms:|C|C:|C:\','GetDriveSerial',ICON:EXCLAMATION)
	END

DI_GetDriveLabel  PROCEDURE(DriveLetter)
RootPathName	CSTRING(20)
OldErrorMode	LONG
DriveType	LONG
DriveRemoteName	CSTRING(260)
DriveRemoteSize	LONG
VolumeName      CSTRING(256)
VolumeNameSize  ULONG(256)
VolSerialNum    ULONG(15)
MaxCompLen      ULONG(15)
FileSysFlags    ULONG(15)
FileSysName     CSTRING(256)
FileSName       ULONG(256)
        CODE
	IF LEN(DriveLetter) = 3 AND SUB(DriveLetter,-1,1) = '\'
	  RootPathName = DriveLetter
	  DriveType = DI_GetDriveType(RootPathName)
	  IF DriveType = 4
	    RootPathName = SUB(DriveLetter,1,2)
            DriveRemoteSize = SIZE(DriveRemoteName)
            T# = DI_WNetGetConnection(ADDRESS(RootPathName),ADDRESS(DriveRemoteName),ADDRESS(DriveRemoteSize))
            Return(DriveRemoteName)
	  ELSE
	    RootPathName = DriveLetter
            OldErrorMode = DI_SetErrorMode(SEM_FAILCRITICALERRORS)
            DI_GetVolumeInformation(RootPathName, VolumeName, VolumeNameSize, VolSerialNum, MaxCompLen, FileSysFlags, FileSysName, FileSName)
            DI_SetErrorMode(OldErrorMode)
            Return(VolumeName)
	  END
	ELSIF LEN(DriveLetter) = 2 AND SUB(DriveLetter,-1,1) = ':'
	  RootPathName = DriveLetter &'\'
	  DriveType = DI_GetDriveType(RootPathName)
	  IF DriveType = 4
	    RootPathName = DriveLetter
            DriveRemoteSize = SIZE(DriveRemoteName)
            T# = DI_WNetGetConnection(ADDRESS(RootPathName),ADDRESS(DriveRemoteName),ADDRESS(DriveRemoteSize))
            Return(DriveRemoteName)
	  ELSE
	    RootPathName = DriveLetter &'\'
            OldErrorMode = DI_SetErrorMode(SEM_FAILCRITICALERRORS)
            DI_GetVolumeInformation(RootPathName, VolumeName, VolumeNameSize, VolSerialNum, MaxCompLen, FileSysFlags, FileSysName, FileSName)
            DI_SetErrorMode(OldErrorMode)
            Return(VolumeName)
	  END
	ELSIF LEN(DriveLetter) = 1
	  RootPathName = DriveLetter &':\'
	  DriveType = DI_GetDriveType(RootPathName)
	  IF DriveType = 4
	    RootPathName = DriveLetter &':'
            DriveRemoteSize = SIZE(DriveRemoteName)
            T# = DI_WNetGetConnection(ADDRESS(RootPathName),ADDRESS(DriveRemoteName),ADDRESS(DriveRemoteSize))
            Return(DriveRemoteName)
	  ELSE
	    RootPathName = DriveLetter &':\'
            OldErrorMode = DI_SetErrorMode(SEM_FAILCRITICALERRORS)
            DI_GetVolumeInformation(RootPathName, VolumeName, VolumeNameSize, VolSerialNum, MaxCompLen, FileSysFlags, FileSysName, FileSName)
            DI_SetErrorMode(OldErrorMode)
            Return(VolumeName)
	  END
	ELSE
	  MESSAGE('The driveletter specified needs|to be formated in one of these forms:|C|C:|C:\','GetDriveLabel',ICON:EXCLAMATION)
	END

DI_ChangeLongToHex PROCEDURE(ULONG in, BYTE LowerCase)
Out STRING(8),AUTO
Inb BYTE,DIM(4),OVER(in)
  CODE
  Out[1 : 2] = DI_ChangeByteToHex(Inb[4], LowerCase)
  Out[3 : 4] = DI_ChangeByteToHex(Inb[3], LowerCase)
  Out[5 : 6] = DI_ChangeByteToHex(Inb[2], LowerCase)
  Out[7 : 8] = DI_ChangeByteToHex(Inb[1], LowerCase)
  RETURN Out

DI_ChangeByteToHex PROCEDURE(BYTE in, BYTE LowerCase)
Out            STRING(2),AUTO
HEX            &STRING,AUTO
HexDigitsUp    STRING('0123456789ABCDEF')
HexDigitsLow   STRING('0123456789abcdef')
  CODE
  IF LowerCase
    HEX &= HexDigitsLow
  ELSE
    HEX &= HexDigitsUp
  END
  Out[1] = HEX [BSHIFT(in, -4) + 1]
  Out[2] = HEX [BAND(in, 0FH) + 1]
  RETURN Out

DI_GetDriveSpace         PROCEDURE(GLOBALDRIVE,SWITCH,ONLYVALUE)
RootPathName                 CSTRING(20)
ReturnValue	             CSTRING(250)
DiskSpace	    	     GROUP,TYPE
lpSectorsPerCluster	     ULONG
lpBytesPerSector	     ULONG
lpNumberOfFreeClusters       ULONG
lpTotalNumberOfClusters	     ULONG
	END
lpFreeBytesAvailable	     LIKE(ULARGE_INTEGER),AUTO
lpTotalNumberOfBytes	     LIKE(ULARGE_INTEGER),AUTO
lpTotalNumberOfFreeBytes     LIKE(ULARGE_INTEGER),AUTO
FreeBytesAvailable	     DECIMAL(21)
TotalNumberOfBytes	     DECIMAL(21)
TotalNumberOfFreeBytes       DECIMAL(21)
DS		             LIKE(DiskSpace),AUTO
DriveType		     LONG
OldErrorMode	             LONG
    CODE
    SETCURSOR(CURSOR:WAIT)
    IF LEN(GLOBALDRIVE) = 3 AND SUB(GLOBALDRIVE,-1,1) = '\'
      RootPathName = UPPER(CLIP(GLOBALDRIVE))
    ELSIF LEN(GLOBALDRIVE) = 2 AND SUB(GLOBALDRIVE,-1,1) = ':'
      RootPathName = UPPER(CLIP(GLOBALDRIVE)) &'\'
    ELSE
      RootPathName = UPPER(CLIP(GLOBALDRIVE)) &':\'
    END
    DriveType    = DI_GetDriveType(RootPathName)
    IF DriveType = 2 OR DriveType = 5
      IF ~DI_GetDriveLabel(RootPathName)
        ReturnValue = ''
      ELSE
        DI_GetDiskFreeSpace(ADDRESS(RootPathName),lpFreeBytesAvailable,lpTotalNumberOfBytes,lpTotalNumberOfFreeBytes)
        FreeBytesAvailable	    = ((lpFreeBytesAvailable.HighDw * 4294967296) + lpFreeBytesAvailable.LowDw)
        TotalNumberOfBytes	    = ((lpTotalNumberOfBytes.HighDw * 4294967296) + lpTotalNumberOfBytes.LowDw)
        TotalNumberOfFreeBytes      = ((lpTotalNumberOfFreeBytes.HighDw * 4294967296) + lpTotalNumberOfFreeBytes.LowDw)
        CASE SWITCH
        OF 1 !Total Space
          IF ONLYVALUE
            ReturnValue = TotalNumberOfBytes
          ELSE
            ReturnValue = DI_FormatBytesSize(TotalNumberOfBytes)
          END
        OF 2 !Total Free
          IF ONLYVALUE
            ReturnValue = TotalNumberOfFreeBytes
          ELSE
            ReturnValue = DI_FormatBytesSize(TotalNumberOfFreeBytes)
          END
        OF 3 !Available Free
          IF ONLYVALUE
            ReturnValue = TotalNumberOfFreeBytes
          ELSE
            ReturnValue = DI_FormatBytesSize(TotalNumberOfFreeBytes)
          END
        OF 4 !Total space used
          IF ONLYVALUE
            ReturnValue = (TotalNumberOfBytes-TotalNumberOfFreeBytes)
          ELSE
            ReturnValue = DI_FormatBytesSize((TotalNumberOfBytes-TotalNumberOfFreeBytes))
          END
        END
      END
    ELSE
      DI_GetDiskFreeSpace(ADDRESS(RootPathName),lpFreeBytesAvailable,lpTotalNumberOfBytes,lpTotalNumberOfFreeBytes)
      FreeBytesAvailable	    = ((lpFreeBytesAvailable.HighDw * 4294967296) + lpFreeBytesAvailable.LowDw)
      TotalNumberOfBytes	    = ((lpTotalNumberOfBytes.HighDw * 4294967296) + lpTotalNumberOfBytes.LowDw)
      TotalNumberOfFreeBytes      = ((lpTotalNumberOfFreeBytes.HighDw * 4294967296) + lpTotalNumberOfFreeBytes.LowDw)
      CASE SWITCH
      OF 1 !Total Space
        IF ONLYVALUE
          ReturnValue = TotalNumberOfBytes
        ELSE
          ReturnValue = DI_FormatBytesSize(TotalNumberOfBytes)
        END
      OF 2 !Total Free
        IF ONLYVALUE
          ReturnValue = TotalNumberOfFreeBytes
        ELSE
          ReturnValue = DI_FormatBytesSize(TotalNumberOfFreeBytes)
        END
      OF 3 !Available Free
        IF ONLYVALUE
          ReturnValue = TotalNumberOfFreeBytes
        ELSE
          ReturnValue = DI_FormatBytesSize(TotalNumberOfFreeBytes)
        END
      OF 4 !Total space used
        IF ONLYVALUE
          ReturnValue = (TotalNumberOfBytes-TotalNumberOfFreeBytes)
        ELSE
          ReturnValue = DI_FormatBytesSize((TotalNumberOfBytes-TotalNumberOfFreeBytes))
        END
      END
    END
    SETCURSOR()
    RETURN(ReturnValue)

DI_FormatBytesSize	PROCEDURE(OrgSize)
ReturnValue	CSTRING(50)
KB	 REAL
MB	 REAL
GB	 REAL
TB 	 REAL
CALCSIZE REAL
         CODE

	KB = 1024
	MB = KB * KB
	GB = MB * KB
	TB = GB * KB

	IF OrgSize < 1024 AND OrgSize > 0
	  ReturnValue = ROUND(OrgSize,.01) &' Bytes'
	ELSIF OrgSize = 0
	ELSE
	  IF OrgSize >= TB
	    CALCSIZE    = (OrgSize/TB)
	    ReturnValue = ROUND(CALCSIZE,.01) &' TB'
	  ELSIF OrgSize >= GB
	    CALCSIZE    = (OrgSize/GB)
	    ReturnValue = ROUND(CALCSIZE,.01) &' GB'
	  ELSIF OrgSize >= MB
	    CALCSIZE    = (OrgSize/MB)
	    ReturnValue = ROUND(CALCSIZE,.01) &' MB'
	  ELSE
	    CALCSIZE    = (OrgSize/KB)
	    ReturnValue = ROUND(CALCSIZE,.01) &' KB'
	  END
	END
	RETURN(ReturnValue)

! ------------------------------------------------------------------------------------- !
DriveInfo.Construct PROCEDURE
! Auto constructor
! ------------------------------------------------------------------------------------- !
  CODE
  SELF.SendDebug('Version: '& (DriveInfoVersion/100))
  SELF.DiskInfoQ   &= NEW(DiskInfoQ)
  SELF.KnownDriveQ &= NEW(KnownDriveQ)
  SELF.NewDriveQ   &= NEW(NewDriveQ)
  SELF.DiscDriveQ  &= NEW(DiscDriveQ)


! ------------------------------------------------------------------------------------- !
DriveInfo.Destruct PROCEDURE
! Auto desctructor
! ------------------------------------------------------------------------------------- !
  CODE
  DISPOSE(SELF.DiskInfoQ)
  DISPOSE(SELF.KnownDriveQ)
  DISPOSE(SELF.NewDriveQ)
  DISPOSE(SELF.DiscDriveQ)

! ------------------------------------------------------------------------------------- !
DriveInfo.SendDebug PROCEDURE(STRING MyDebugString)
! Send debuginfo
! ------------------------------------------------------------------------------------- !
MyDebugInformation	CSTRING(260)
  CODE
  IF INSTRING('/DEBUGDRIVEINFOCLASS',UPPER(COMMAND('')),1,1)
    MyDebugInformation= '[Drive Information] - '& MyDebugString
    DI_OutputDebugString(MyDebugInformation)
  END

! ------------------------------------------------------------------------------------- !
DriveInfo.CheckNewDrives  PROCEDURE()
! Check for new drives.
! ------------------------------------------------------------------------------------- !
Drives   STRING('CDEFGHIJKLMNOPQRSTUVWXYZ')
RootPathName         CSTRING(4)
KDriveQ              QUEUE
Drive                  STRING(3)
                     END
  CODE
  SELF.SendDebug('[CheckNewDrives]')
  FREE(SELF.NewDriveQ)
  FREE(SELF.DiscDriveQ)
  LOOP I# = 1 TO 24
    RootPathName  = Drives[ I# ] & ':\'
    SELF.SendDebug('Checking drive: '& RootPathName)
    DT# = DI_GetDriveType(RootPathName)
    IF DT# = 2
      KDriveQ.Drive = RootPathName
      ADD(KDriveQ)
      SELF.KnownDriveQ.Drive = RootPathName
      GET(SELF.KnownDriveQ,SELF.KnownDriveQ.Drive)
      IF ERRORCODE()
        SELF.NewDriveQ.Drive = RootPathName
        ADD(SELF.NewDriveQ)
        SELF.SendDebug('Drive '& RootPathName &' is unknown!')
      ELSE
        SELF.SendDebug('Drive '& RootPathName &' was already known.')
      END
    END
  END
  LOOP TELLER#=1 TO RECORDS(SELF.KnownDriveQ)
    GET(SELF.KnownDriveQ,TELLER#)
    IF ~ERRORCODE()
      KDriveQ.Drive = SELF.KnownDriveQ.Drive
      GET(KDriveQ,KDriveQ.Drive)
      IF ERRORCODE()
        SELF.DiscDriveQ.Drive = SELF.KnownDriveQ.Drive
        ADD(SELF.DiscDriveQ)
        SELF.SendDebug('Drive '& RootPathName &' is disconnected!')
      END
    END
  END
  SELF.SetCheckPoint()
  IF RECORDS(Self.NewDriveQ) OR RECORDS(SELF.DiscDriveQ)
    RETURN(TRUE)
  ELSE
    RETURN(FALSE)
  END

! ------------------------------------------------------------------------------------- !
DriveInfo.SetCheckPoint  PROCEDURE()
! Set the known drives checkpoint.
! ------------------------------------------------------------------------------------- !
Drives   STRING('CDEFGHIJKLMNOPQRSTUVWXYZ')
RootPathName         CSTRING(4)
  CODE
  SELF.SendDebug('[SetCheckPoint]')
  FREE(SELF.KnownDriveQ)
  LOOP I# = 1 TO 24
    RootPathName  = Drives[ I# ] & ':\'
    DT# = DI_GetDriveType(RootPathName)
    IF DT# = 2
      SELF.KnownDriveQ.Drive = RootPathName
      ADD(SELF.KnownDriveQ)
      SELF.SendDebug('Adding '& RootPathName &' to known drives list.')
    END
  END

! ------------------------------------------------------------------------------------- !
DriveInfo.EnumerateDrives  PROCEDURE()
! Fill the global queue with drives
! ------------------------------------------------------------------------------------- !
Drives               STRING('CDEFGHIJKLMNOPQRSTUVWXYZ')
RootPathName         CSTRING(4)
VolumeName           CSTRING(256)
VolumeNameSize       ULONG(256)
VolSerialNum         ULONG(15)
MaxCompLen           ULONG(15)
FileSysFlags         ULONG(15)
FileSysName          CSTRING(256)
FileSName            ULONG(256)
sTemp		     CSTRING(10)
DriveLocalName	     CSTRING(20)
DriveRemoteName	     CSTRING(260)
DriveRemoteSize	     LONG
OldErrorMode	     LONG
lpUserName	     CSTRING(100)
TmpDriveType	     LONG
  CODE
  SETCURSOR(CURSOR:WAIT)
  FREE(SELF.DiskInfoQ)
  LOOP I# = 1 TO 24
    RootPathName  = Drives[ I# ] & ':\'
    SELF.DiskInfoQ.Drive     = RootPathName
    GET(SELF.DiskInfoQ,SELF.DiskInfoQ.Drive)
    IF ERRORCODE()
    TmpDriveType = CLIP(DI_GetDriveType(SELF.DiskInfoQ.Drive))
    IF TmpDriveType <> 1
      CLEAR(VolumeName)
      CLEAR(FileSysName)
      CLEAR(VolSerialNum)
      CLEAR(lpUserName)
      OldErrorMode = DI_SetErrorMode(SEM_FAILCRITICALERRORS)
      DI_GetVolumeInformation(RootPathName, VolumeName, VolumeNameSize, VolSerialNum, MaxCompLen, FileSysFlags, FileSysName, FileSName)
      DI_SetErrorMode(OldErrorMode)
      IF TmpDriveType  = 4
        DriveLocalName  = Drives[ I# ] &':'
        DriveRemoteSize = SIZE(DriveRemoteName)
        T# = DI_WNetGetConnection(ADDRESS(DriveLocalName),ADDRESS(DriveRemoteName),ADDRESS(DriveRemoteSize))
        SELF.DiskInfoQ.DriveLabel  = DriveRemoteName
        DriveRemoteSize = SIZE(lpUserName)
	DI_WNetGetUser(ADDRESS(DriveLocalName),ADDRESS(lpUserName),ADDRESS(DriveRemoteSize))
      ELSE
        SELF.DiskInfoQ.DriveLabel  = VolumeName
      END
      IF TmpDriveType = 2 AND ~SELF.DiskInfoQ.DriveLabel
        SELF.DiskInfoQ.TotalSpace     = ''
        SELF.DiskInfoQ.TotalFreeSpace = ''
        SELF.DiskInfoQ.TotalUsedSpace = ''
      ELSIF SELF.DiskInfoQ.DriveType = 5 AND ~SELF.DiskInfoQ.DriveLabel
        SELF.DiskInfoQ.TotalSpace     = ''
        SELF.DiskInfoQ.TotalFreeSpace = ''
        SELF.DiskInfoQ.TotalUsedSpace = ''
      ELSE
        SELF.DiskInfoQ.TotalSpace      = DI_GetDriveSpace(Drives[ I# ],1,FALSE)
        SELF.DiskInfoQ.TotalFreeSpace  = DI_GetDriveSpace(Drives[ I# ],2,FALSE)
        SELF.DiskInfoQ.TotalUsedSpace  = DI_GetDriveSpace(Drives[ I# ],4,FALSE)
      END
      IF TmpDriveType = 0 THEN SELF.DiskInfoQ.DriveType = 'Unknown'.
      IF TmpDriveType = 1 THEN SELF.DiskInfoQ.DriveType = 'No Root Dir'.
      IF TmpDriveType = 2 THEN SELF.DiskInfoQ.DriveType = 'Removable'.
      IF TmpDriveType = 3 THEN SELF.DiskInfoQ.DriveType = 'Fixed'.
      IF TmpDriveType = 4 THEN SELF.DiskInfoQ.DriveType = 'Remote'.
      IF TmpDriveType = 5 THEN SELF.DiskInfoQ.DriveType = 'CD-ROM'.
      IF TmpDriveType = 6 THEN SELF.DiskInfoQ.DriveType = 'Ramdisk'.
      SELF.DiskInfoQ.DriveFAT    = FileSysName
      IF VolSerialNum > 0
        sTemp = DI_ChangeLongToHex(VolSerialNum,0)
        SELF.DiskInfoQ.DriveSerial = SUB(sTemp,1,4) &'-'& SUB(sTemp,5,4)
      ELSE
        SELF.DiskInfoQ.DriveSerial = ''
      END
      IF lpUserName
        SELF.DiskInfoQ.RemoteUser = lpUserName
      ELSE
        SELF.DiskInfoQ.RemoteUser = ''
      END
      ADD(SELF.DiskInfoQ)
    END
    END
  END
  SETCURSOR()
